/* All Rights Reserved */

#import "AppController.h"
#import <AppKit/AppKit.h>

@interface AppController (Private)

- (NSDictionary *) getArgs;

@end

@implementation AppController

- (void) openImage: sender
{
  NSOpenPanel *op = [NSOpenPanel openPanel];

  [op setCanChooseDirectories: NO];
  [op setCanChooseFiles: YES];
  [op setTitle: _(@"Open PaVe Image")];

  if ([op runModalForTypes: [NSArray arrayWithObject: @"pave"]] == NSOKButton)
    {
      ASSIGN (path, [op filename]);

      [imageView loadImageAtPath: path
                       arguments: [self getArgs]];
    }
}

- (void) reloadImage: sender
{
  [imageView loadImageAtPath: path arguments: [self getArgs]];
}

@end

@implementation AppController (Private)

- (NSDictionary *) getArgs
{
  NSData *d = [[NSString stringWithFormat: @"{%@}", [args text]]
    dataUsingEncoding: NSUTF8StringEncoding];

  NSDictionary *dict = [NSPropertyListSerialization
    propertyListFromData: d
        mutabilityOption: NSPropertyListImmutable
                  format: NULL
        errorDescription: NULL];

  if ([dict isKindOfClass: [NSDictionary class]])
    {
      return dict;
    }
  else
    {
      NSRunAlertPanel (_(@"Error parsing arguments"),
        _(@"There appears to be a syntax error in your 'Arguments' plist"),
        nil, nil, nil);

      return nil;
    }
}

@end
