/*
 * Created by diablos on 2007-12-02 18:57:19 +0100
 * All Rights Reserved
 */

#import "PaVeImageView.h"

@implementation PaVeImageView

- (void) loadImageAtPath: (NSString *) aPath
               arguments: (NSDictionary *) arg
{
  NSData *d = [NSData dataWithContentsOfFile: aPath];

  if (d == nil)
    {
      NSRunAlertPanel (_(@"Error loading image"),
        _(@"Couldn't read image file data - maybe an access privs problem?"),
        nil, nil, nil);

      return;
    }

  Class c = [NSImageRep imageRepClassForFileType: @"pave"];

  if (c == Nil)
    {
      NSRunAlertPanel (_(@"Error loading image"),
        _(@"Couldn't find class to handle image data. It seems you "
          @"haven't loaded the PaVe bundle"),
        nil, nil, nil);

      return;
    }

  DESTROY (paveImage);
  paveImage = [[c alloc] initWithData: d];
  if (paveImage == nil)
    {
      NSRunAlertPanel (_(@"Error loading image"),
        _(@"Failed to initialize PaVe image with image data. The image "
          @"probably isn't a valid PaVe image."),
        nil, nil, nil);

      return;
    }

  ASSIGN (args, arg);

  [self setNeedsDisplay: YES];
}

- (void) drawRect: (NSRect) r
{
  NSSize s = [self frame].size;

  [paveImage drawInRect: NSMakeRect (0, 0, s.width, s.height)
              arguments: args];
}

- (void) redraw: sender
{
  [self setNeedsDisplay: YES];
}

@end
